## multipath-tools 0.11.1

=== Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#

TOPDIR := .

LIB_BUILDDIRS := \
	libmpathcmd \
	libmpathutil \
	libmultipath \
	libmpathpersist \
	libmpathvalid

ifneq ($(ENABLE_LIBDMMP),0)
LIB_BUILDDIRS += \
	libdmmp
endif

PLUGIN_BUILDDIRS := \
	libmultipath/prioritizers \
	libmultipath/checkers \
	libmultipath/foreign \

BUILDDIRS := $(LIB_BUILDDIRS) \
	$(PLUGIN_BUILDDIRS) \
	multipath \
	multipathd \
	mpathpersist \
	kpartx


BUILDDIRS.clean := $(BUILDDIRS:=.clean) tests.clean

.PHONY:	$(BUILDDIRS)

all:	$(BUILDDIRS)

config.mk libmultipath/autoconfig.h:
	@$(MAKE) -f create-config.mk
ifeq ($(V),1)
	@echo ==== config.mk ====
	@cat config.mk
	@echo ==== autoconfig.h ====
	@cat libmultipath/autoconfig.h
endif

$(BUILDDIRS):	config.mk
	@$(MAKE) -C $@

$(LIB_BUILDDIRS:=.abi): $(LIB_BUILDDIRS)
	@$(MAKE) -C ${@:.abi=} abi

# Create formal representation of the ABI
# Useful for verifying ABI compatibility
# Requires abidw from the abigail suite (https://sourceware.org/libabigail/)
.PHONY: abi
abi:	$(LIB_BUILDDIRS:=.abi)
	@echo creating abi
	@mkdir -p $@
	$(Q)ln -ft $@ $(LIB_BUILDDIRS:=/*.abi)

abi.tar.gz:	abi
	$(Q)tar cfz $@ abi

# Check the ABI against a reference.
# This requires the ABI from a previous run to be present
# in the directory "reference-abi"
# Requires abidiff from the abigail suite
abi-test:	abi reference-abi $(wildcard abi/*.abi)
	@err=0; \
	for lib in abi/*.abi; do \
	    diff=$$(abidiff --redundant "reference-$$lib" "$$lib") || { \
	        err=1; \
		echo "==== ABI differences in for $$lib ===="; \
		echo "$$diff"; \
	    }; \
	done >$@; \
	if [ $$err -eq 0 ]; then \
	    echo "*** OK, ABI unchanged ***"; \
	else \
	    echo "*** WARNING: ABI has changed, see file $@ ***"; \
	fi; \
	[ $$err -eq 0 ]

# Create compile_commands.json, useful for using clangd with an IDE
# Requires bear (https://github.com/rizsotto/Bear)
compile_commands.json: Makefile Makefile.inc $(BUILDDIRS:=/Makefile)
	$(Q)$(MAKE) clean
	$(Q)bear -- $(MAKE) WARN_ONLY=1 test-progs || rm $@

libmpathutil libdmmp: libmpathcmd
libmultipath: libmpathutil
libmpathpersist libmpathvalid multipath multipathd: libmultipath
libmultipath/prioritizers libmultipath/checkers libmultipath/foreign: libmultipath
mpathpersist multipathd:  libmpathpersist

libmultipath/checkers.install \
	libmultipath/prioritizers.install \
	libmultipath/foreign.install: libmultipath.install

%.clean:
	@$(MAKE) -C ${@:.clean=} clean

%.install:	%
	@$(MAKE) -C ${@:.install=} install

$(BUILDDIRS:=.uninstall):
	@$(MAKE) -C ${@:.uninstall=} uninstall

# If config.mk is missing, "make clean" in subdir either fails, or tries to
# build it. Both is undesirable. Avoid it by creating config.mk temporarily.
clean:
	@touch config.mk
	$(Q)$(MAKE) $(BUILDDIRS:=.clean) tests.clean || true
	$(Q)$(RM) -r abi abi.tar.gz abi-test config.mk

install: $(BUILDDIRS:=.install)
uninstall: $(BUILDDIRS:=.uninstall)

test-progs:	all
	@$(MAKE) -C tests progs

test:	all
	@$(MAKE) -C tests all

valgrind-test:	all
	@$(MAKE) -C tests valgrind

TEST-ARTIFACTS := config.mk Makefile.inc \
	$(LIB_BUILDDIRS:%=%/*.so*) $(PLUGIN_BUILDDIRS:%=%/*.so) \
	tests/Makefile tests/*.so* tests/lib/* tests/*-test 

test-progs.cpio: test-progs
	@printf "%s\\n" $(TEST-ARTIFACTS) | cpio -o -H crc >$@

test-progs.tar: test-progs
	@tar cf $@ $(TEST-ARTIFACTS)

.PHONY:	TAGS
TAGS:
	@etags -a libmultipath/*.c
	@etags -a libmultipath/*.h
	@etags -a multipathd/*.c
	@etags -a multipathd/*.h

=== debian/changelog ===
multipath-tools (0.11.1-3ubuntu2) questing; urgency=medium

  * d/initramfs/scripts/init-top: ensure the bindings file exists before
    calling multipathd -B in the initramfs. This prevents multipathd -B from
    failing and exiting immediately (LP: #2120444).

 -- Olivier Gayot <olivier.gayot@canonical.com>  Tue, 12 Aug 2025 14:36:47 +0200

multipath-tools (0.11.1-3ubuntu1) questing; urgency=medium

  * Merge with Debian experimental (LP: #2117378). Remaining changes:
    - d/rules: no binary package multipath-tools on i386; only kpartx.
    - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
      default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
    - d/t/initramfs: determine extracted main cpio path dynamically
    - d/NEWS: add removal of kpartx-boot package
    - d/rules: remove -Bsymbolic-functions from LDFLAGS
    - d/rules: install friendly names multipath.conf by default
    - d/initramfs: fix multipathd process lingering when local-* initramfs
      scripts are not executed. The multipathd process is started by a script
      in init-top/ (which is executed unconditionally) so it should be
      stopped by an init-bottom script, not a local-bottom script which is
      not always executed (LP #2080474).
      + This is affecting the Ubuntu installer, where we execute (perhaps
        accidentally) the nfs-* scripts instead of the local-* scripts.

 -- Jonas Jelten <jonas.jelten@canonical.com>  Tue, 05 Aug 2025 16:59:52 +0200

multipath-tools (0.11.1-3) experimental; urgency=medium

  * [707b59b] Split off libraries, install dev files.
    Only libmpathcmd, libmpathpersist, libmpathvalid are stable libraries.
    Unfortunately we have to install libmultipath.so into libmultipath-dev
    so qemu-pr-helper will be able to link libmpathpersist.
    See Launchpad bug #2117378 and
    http://github.com/opensvc/multipath-tools/issues/118 for discussion.
    (Closes: #1005323)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 31 Jul 2025 18:45:31 +0200

multipath-tools (0.11.1-2ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2110438). Remaining changes:
    - d/rules: don't build the multipath-tools binary package on i386; only kpartx.
    - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
      default -- see the removed 'add_find-multipaths.patch' (LP 1463046)
    - d/t/initramfs: determine extracted main cpio path dynamically
    - d/NEWS: add removal of kpartx-boot package
    - d/rules: remove -Bsymbolic-functions from LDFLAGS
    - d/rules: install friendly names multipath.conf by default
  * Drop changes:
    - d/t/tgtbasedmpaths: allow rc of 3 for socket (LP #2078888)
      [included in 0.11.1-2]
    - dmsetup version restriction lift
      + Revert dmsetup downgrade (LP #2073622)
      + d/control: allow older dmsetup
      [cancel each other out]
    - d/t/{control,initramfs}: fix initramfs dep8 test
      [merged with "determine extracted main cpio path dynamically"]
  [ Olivier Gayot ]
  * d/initramfs: fix multipathd process lingering when local-* initramfs
    scripts are not executed. The multipathd process is started by a script in
    init-top/ (which is executed unconditionally) so it should be
    stopped by an init-bottom script, not a local-bottom script which is
    not always executed (LP: #2080474).
    - This is affecting the Ubuntu installer, where we execute (perhaps
      accidentally) the nfs-* scripts instead of the local-* scripts.

 -- Jonas Jelten <jonas.jelten@canonical.com>  Wed, 23 Jul 2025 12:06:34 +0200

multipath-tools (0.11.1-2) unstable; urgency=medium

  [ Fabian Grünbichler ]
  * [3e795aa] build: properly split -arch and -indep builds

  [ mitchdz ]
  * [7322e89] d/t/tgtbasedmpaths: allow rc of 3 for socket

  [ Chris Hofstaedtler ]
  * [9c54e80] Install grep, pidof into the initramfs.
    Thanks to Jarl Gullberg <jarl.gullberg@gmail.com> (Closes: #1104259)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 01 May 2025 21:45:28 +0200

multipath-tools (0.11.1-1) unstable; urgency=medium

  * [ed5f513] New upstream version 0.11.1
  * [b9fd90c] tests: allow multipathd.socket to be inactive
  * [bbfe6bb] add myself to uploaders

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 17 Feb 2025 16:40:48 +0100

multipath-tools (0.10.0-1) experimental; urgency=medium

  [ Fabian Grünbichler ]
  * [bde2c42] New upstream version 0.10.0
  * [705138c] rebase patches for 0.10.0
  * [43cefdf] cherry-pick regression fix from upstream 0.11 draft

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 26 Dec 2024 15:16:06 +0100

multipath-tools (0.9.9-1ubuntu4) plucky; urgency=medium

  * debian/tests/initramfs: determine extracted main cpio path dynamically

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 30 Jan 2025 19:48:38 +0100

multipath-tools (0.9.9-1ubuntu3) oracular; urgency=medium

  * d/t/tgtbasedmpaths: allow return code of 3 for socket (LP: #2078888).
    A new line was added to tgtbasedmpaths test to check the status of the
    socket. One some architectures, the socket is inactive, which is fine to
    be in as long as the rest of the test passes. This allows a return code
    of either 0 or 3 from systemctl when checking the socket.

 -- Mitchell Dzurick <mitchell.dzurick@canonical.com>  Tue, 03 Sep 2024 20:28:27 -0700

multipath-tools (0.9.9-1ubuntu2) oracular; urgency=medium

  * Revert dmsetup downgrade (LP: #2073622).
    - d/control: require dmsetup (>= 2:1.02.196-1~)
    - remove d/p/0002-11-dm-mpath.in-fix-DM_UDEV_RULES_VSN-check.patch
    - This was needed originally due to lvm2 package being older, but due to the
      package upgrade, these changes can be dropped.

 -- Mitchell Dzurick <mitchell.dzurick@canonical.com>  Tue, 23 Jul 2024 06:41:53 -0700

multipath-tools (0.9.9-1ubuntu1) oracular; urgency=medium

  * Merge with Debian unstable (LP: #2068645). Remaining changes:
    - Don't build the multipath-tools binary package on i386; only kpartx.


=== debian/control ===
Source: multipath-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian DM Multipath Team <team+linux-blocks@tracker.debian.org>
Uploaders:
 Guido Günther <agx@sigxcpu.org>,
 Ritesh Raj Sarraf <rrs@debian.org>,
 Chris Hofstaedtler <zeha@debian.org>,
 Fabian Grünbichler <debian@fabian.gruenbichler.email>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 libaio-dev,
 libdevmapper-dev,
 libedit-dev,
 libmount-dev,
 libjson-c-dev,
 libsystemd-dev,
 libudev-dev,
 liburcu-dev,
 pkgconf,
 systemd-dev,
Vcs-Git: https://salsa.debian.org/linux-blocks-team/multipath-tools.git
Vcs-Browser: https://salsa.debian.org/linux-blocks-team/multipath-tools
Standards-Version: 3.9.8
Homepage: http://christophe.varoqui.free.fr/
Rules-Requires-Root: no

Package: multipath-tools
Architecture: linux-any
Depends:
 kpartx (>= ${binary:Version}),
 sg3-utils-udev,
 udev,
# need systemd >= 245 for modprobe@dm_multipath.service
 systemd (>= 245~),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Suggests:
 multipath-tools-boot,
Description: maintain multipath block device access
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.
 .
 If you install this package you may have to change the way you address block
 devices. See README.Debian for details.

Package: kpartx
Architecture: linux-any
Depends:
# need dmsetup >= 2:1.02.196-1 to get non-broken DM_UDEV_RULES_VSN in their udev rules
 dmsetup (>= 2:1.02.196-1~),
 udev,
 ${misc:Depends},
 ${shlibs:Depends},
Description: create device mappings for partitions
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device.
 .
 It is part of the Linux multipath-tools, but is useful on any
 device-mapper using system.

Package: multipath-tools-boot
Architecture: all
Depends:
 initramfs-tools | linux-initramfs-tool,
 multipath-tools (<< ${source:Version}.1~),
 multipath-tools (>= ${source:Version}),
 ${misc:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Support booting from multipath devices
 This package contains the necessary support for booting from a multipath
 device:
 .
  * copy over multipath.conf and persistent bindings if necessary
  * load the necessary kernel modules
  * detect multipath block devices
 .
 Don't install this package if you're not booting from a multipath device.

Package: multipath-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 kpartx-udeb,
 multipath-modules,
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: maintain multipath block device access - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 These tools are in charge of maintaining the disk multipath device maps and
 react to path and map events.

Package: kpartx-udeb
Package-Type: udeb
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: debian-installer
Description: create device mappings for partitions - udeb package
 This is a udeb, or a microdeb, for the debian-installer.
 .
 Kpartx can be used to set up device mappings for the partitions of any
 partitioned block device. It is part of the Linux multipath-tools.

Package: libmultipath0
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath-tools internal libraries
 This package contains libraries considered internal to the multipath
 system / daemon.
 No package apart from src:multipath-tools is allowed to use symbols
 from libraries shipped by this package.

Package: libmultipath-dev
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 libmultipath0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath-tools internal libraries - development files
 This package contains the link necessary for dynamically linking
 internal libraries of the multipath system.
 No package apart from src:multipath-tools is allowed to use symbols
 from libraries shipped by this package. The only supported use is
 to allow usage of libmpathcmd-dev and libmpathpersist-dev.

Package: libmpathcmd0
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath command library
 This is the runtime library for submitting commands to the multipath
 system / daemon.

Package: libmpathcmd-dev
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 libmpathcmd0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath command library - development files
 This package allows development of applications using the command
 library for the multipath system / daemon. It includes headers, libraries
 and links to allow dynamic linking.

Package: libmpathpersist0
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath persist library
 This is the runtime library for managing SCSI persistent reservations
 on multipath devices.

Package: libmpathpersist-dev
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 libmpathpersist0 (= ${binary:Version}),
 libmultipath-dev (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath persist library - development files
 This package allows development of applications using the persistent
 reservation library for multipath devices. It includes headers, libraries
 and links to allow dynamic linking.

Package: libmpathvalid0
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Section: libs
Description: multipath valid library
 This is the runtime library for checking devices if they are managed
 by the multipath system.

Package: libmpathvalid-dev
Architecture: linux-any
Breaks: multipath-tools (<< 0.11.1-3~)
Replaces: multipath-tools (<< 0.11.1-3~)
Depends:
 libmpathvalid0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Section: libdevel
Description: multipath valid library - development files
 This package allows development of applications using the validation
 library for multipath devices. It includes headers, libraries
 and links to allow dynamic linking.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
	skip_packages = -Nmultipath-tools
endif

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# Reproducible timestamp
export KBUILD_BUILD_TIMESTAMP = "@$(SOURCE_DATE_EPOCH)"

# Disable libdmmp, no known users exist
export ENABLE_LIBDMMP=0

TREENAMES = build-deb build-udeb

%:
	dh $@

execute_before_dh_clean:
	for treename in $(TREENAMES); do \
		rm -rf debian/$$treename ;\
	done
	# Force recreation of docs re. reproducibility
	rm -fv libdmmp/docs/man/dmmp_strerror.3

execute_before_dh_auto_configure:
	# no out of tree build support, prepare two source trees
	for treename in $(TREENAMES); do \
		mkdir debian/$$treename ;\
		cp -r -t debian/$$treename $$(find . -mindepth 1 -maxdepth 1 \! -name debian \! -name .git) ;\
	done

override_dh_auto_configure:

override_dh_auto_build-indep:

override_dh_auto_build-arch:
	dh_auto_build --sourcedirectory=debian/build-deb
	# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579); disable systemd
	dh_auto_build --sourcedirectory=debian/build-udeb -- \
		SYSTEMD= EXTRACFLAGS="-static-libgcc"

override_dh_auto_test:

override_dh_auto_install-arch:
	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
	dh_auto_install --sourcedirectory=debian/build-udeb -- DESTDIR=$(CURDIR)/debian/tmp/udeb

	mkdir -p $(CURDIR)/debian/tmp/deb/etc
	cp debian/multipath.conf $(CURDIR)/debian/tmp/deb/etc

	# udebs dont get manpages
	rm -rf $(CURDIR)/debian/tmp/udeb/usr/share/man

	# Delete development files from udebs.
	rm \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_cmd.h \
		$(CURDIR)/debian/tmp/udeb/usr/include/mpath_persist.h \
		$(CURDIR)/debian/tmp/udeb/usr/lib/libm*.so

override_dh_auto_install-indep:

execute_after_dh_install:
	if strings debian/multipath-udeb/usr/lib/libmultipath.so.0 | grep libsystemd.so ; then \
		echo ERROR: udeb linked to libsystemd ;\
		exit 1 ;\
	fi

override_dh_bugfiles:
	dh_bugfiles -A -pmultipath-tools -pmultipath-tools-boot

override_dh_installsystemd:
	dh_installsystemd -pmultipath-tools multipathd.service \
		--no-stop-on-upgrade

override_dh_makeshlibs:
	dh_makeshlibs -a --add-udeb=multipath-udeb

override_dh_builddeb:
	dh_builddeb ${skip_packages}

override_dh_gencontrol:
	dh_gencontrol ${skip_packages}

## multipath-tools 0.12.0

=== kpartx/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

EXEC := kpartx

CPPFLAGS += -I. -I$(multipathdir) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -ldevmapper

OBJS := bsd.o dos.o kpartx.o solaris.o unixware.o dasd.o sun.o \
	gpt.o mac.o ps3.o crc32.o lopart.o xstrncpy.o devmapper.o

all: $(EXEC) kpartx.rules

$(EXEC): $(OBJS)
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)

install: $(EXEC) $(EXEC).8 kpartx.rules
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)
	$(Q)$(INSTALL_PROGRAM) -m 755 kpartx_id $(DESTDIR)$(libudevdir)
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(libudevdir)/rules.d
	$(Q)$(INSTALL_PROGRAM) -m 644 dm-parts.rules $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(Q)$(INSTALL_PROGRAM) -m 644 kpartx.rules $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(Q)$(INSTALL_PROGRAM) -m 644 del-part-nodes.rules $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/kpartx_id
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/11-dm-parts.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/66-kpartx.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/67-kpartx-compat.rules
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/68-del-part-nodes.rules

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) kpartx.rules

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== libdmmp/Makefile ===
# Makefile
#
# Copyright (C) 2015 - 2016 Red Hat, Inc.
# Gris Ge <fge@redhat.com>
#
include ../Makefile.inc

LIBDMMP_VERSION := 0.2.0
SONAME := $(LIBDMMP_VERSION)
DEVLIB := libdmmp.so
PKGFILE := libdmmp.pc
EXTRA_MAN_FILES := libdmmp.h.3
HEADERS := libdmmp/libdmmp.h

OBJS := libdmmp.o libdmmp_mp.o libdmmp_pg.o libdmmp_path.o libdmmp_misc.o

CPPFLAGS += -I$(libdmmpdir) -I$(mpathcmddir) $(shell $(PKG_CONFIG) --cflags json-c)
CFLAGS += $(LIB_CFLAGS) -fvisibility=hidden

LIBDEPS += $(shell $(PKG_CONFIG) --libs json-c) -L$(mpathcmddir) -lmpathcmd -lpthread

all: $(LIBS) doc
.PHONY:	doc clean install uninstall check speed_test dep_clean

$(LIBS): $(OBJS)
	$(Q)$(CC) $(LDFLAGS) $(SHARED_FLAGS) -Wl,-soname=$@ -o $@ $(OBJS) $(LIBDEPS)

$(DEVLIB): $(LIBS)
	$(Q)$(LN) $(LIBS) $@

abi:    $(DEVLIB:%.so=%.abi)

install:
	@mkdir -p $(DESTDIR)$(usrlibdir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(usrlibdir)/$(LIBS)
	$(Q)$(INSTALL_PROGRAM) -m 644 -D \
		$(HEADERS) $(DESTDIR)$(includedir)/$(HEADERS)
	$(Q)$(LN) $(LIBS) $(DESTDIR)$(usrlibdir)/$(DEVLIB)
	$(Q)$(INSTALL_PROGRAM) -m 644 -D \
		$(PKGFILE).in $(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	$(Q)sed -i 's|__VERSION__|$(LIBDMMP_VERSION)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	$(Q)sed -i 's|__LIBDIR__|$(usrlibdir)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	$(Q)sed -i 's|__INCLUDEDIR__|$(includedir)|g' \
		$(DESTDIR)$(pkgconfdir)/$(PKGFILE)
	$(Q)$(INSTALL_PROGRAM) -m 755 -d $(DESTDIR)$(mandir)/man3
	$(Q)$(INSTALL_PROGRAM) -m 644 -t $(DESTDIR)$(mandir)/man3 docs/man/*.3

uninstall:
	$(Q)$(RM) $(DESTDIR)$(usrlibdir)/$(LIBS)
	$(Q)$(RM) $(DESTDIR)$(includedir)/$(HEADERS)
	$(Q)$(RM) $(DESTDIR)$(usrlibdir)/$(DEVLIB)
	@for file in $(DESTDIR)$(mandir)/man3/dmmp_*; do \
		$(RM) $$file; \
	done
	$(Q)$(RM) $(DESTDIR)$(mandir)/man3/libdmmp.h*
	$(Q)$(RM) $(DESTDIR)$(pkgconfdir)/$(PKGFILE)

clean: dep_clean
	$(Q)$(RM) core *.a *.o *.so *.so.* *.abi $(NV_VERSION_SCRIPT)
	@$(MAKE) -C test clean

include $(wildcard $(OBJS:.o=.d))

check: all
	@$(MAKE) -C test check

speed_test: all
	@$(MAKE) -C test speed_test

doc: docs/man/dmmp_strerror.3

docs/man/dmmp_strerror.3:	$(HEADERS)
	$(Q)TEMPFILE=$(shell mktemp); \
	cat $^ | perl docs/doc-preclean.pl >$$TEMPFILE; \
	[ "$$KBUILD_BUILD_TIMESTAMP" ] || \
	    KBUILD_BUILD_TIMESTAMP=`git log -n1 --pretty=%cd --date=iso -- $^`; \
	export KBUILD_BUILD_TIMESTAMP; \
	LC_ALL=C \
	perl docs/kernel-doc -man $$TEMPFILE | \
	    perl docs/split-man.pl docs/man; \
	$(RM) -f $$TEMPFILE

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== mpathpersist/Makefile ===
include ../Makefile.inc

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathpersistdir)
CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)

LIBDEPS += -L$(mpathpersistdir) -lmpathpersist -L$(multipathdir) -lmultipath \
	-L$(mpathutildir) -lmpathutil -L$(mpathcmddir) -lmpathcmd -lpthread -ldevmapper -ludev

EXEC = mpathpersist
MANPAGES := mpathpersist.8

OBJS = main.o

all: $(EXEC) $(MANPAGES)

$(EXEC): $(OBJS)
	$(Q)$(CC) $(OBJS) -o $(EXEC) $(LDFLAGS) $(CFLAGS) $(LIBDEPS)

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(MANPAGES)

include $(wildcard $(OBJS:.o=.d))

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== multipath/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
include ../Makefile.inc

EXEC      := multipath
MANPAGES  := multipath.8 multipath.conf.5
GENERATED := $(MANPAGES) multipath.rules tmpfiles.conf 11-dm-mpath.rules

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathcmddir)
CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)
LIBDEPS += -L$(multipathdir) -lmultipath -L$(mpathutildir) -lmpathutil \
	-L$(mpathcmddir) -lmpathcmd -lpthread -ldevmapper -ldl -ludev

OBJS := main.o

all: $(EXEC) $(GENERATED)

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) -o $(EXEC) $(LDFLAGS) $(LIBDEPS)

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)/
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(udevrulesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 11-dm-mpath.rules $(DESTDIR)$(udevrulesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 99-z-dm-mpath-late.rules $(DESTDIR)$(udevrulesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 multipath.rules $(DESTDIR)$(udevrulesdir)/56-multipath.rules
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(tmpfilesdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 tmpfiles.conf $(DESTDIR)$(tmpfilesdir)/multipath.conf
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man5
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).conf.5 $(DESTDIR)$(mandir)/man5
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(modulesloaddir)
ifeq ($(MODPROBE_UNIT),)
	$(Q)$(INSTALL_PROGRAM) -m 644 modules-load.conf $(DESTDIR)$(modulesloaddir)/multipath.conf
endif
ifneq ($(SCSI_DH_MODULES_PRELOAD),)
	$(Q)$(INSTALL_PROGRAM) -m 644 scsi_dh.conf $(DESTDIR)$(modulesloaddir)/scsi_dh.conf
	$(Q)for _x in $(SCSI_DH_MODULES_PRELOAD); do echo "$$_x"; done \
	    >>$(DESTDIR)$(modulesloaddir)/scsi_dh.conf
endif

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC)
	$(Q)$(RM) $(DESTDIR)$(udevrulesdir)/11-dm-mpath.rules
	$(Q)$(RM) $(DESTDIR)$(udevrulesdir)/99-z-dm-mpath-late.rules
	$(Q)$(RM) $(DESTDIR)$(modulesloaddir)/multipath.conf
	$(Q)$(RM) $(DESTDIR)$(modulesloaddir)/scsi_dh.conf
	$(Q)$(RM) $(DESTDIR)$(libudevdir)/rules.d/56-multipath.rules
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(mandir)/man5/$(EXEC).conf.5
	$(Q)$(RM) $(DESTDIR)$(tmpfilesdir)/multipath.conf

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(GENERATED)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== multipathd/Makefile ===
include ../Makefile.inc

EXEC     := multipathd
CLI      := multipathc
MANPAGES := multipathd.8

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathpersistdir) -I$(mpathcmddir) -I$(thirdpartydir) \
	-DBINDIR='"$(bindir)"' $(SYSTEMD_CPPFLAGS)

#
# debugging stuff
#
#CPPFLAGS += -DLCKDBG
#CPPFLAGS += -DLOGDBG

CFLAGS += $(BIN_CFLAGS)
LDFLAGS += $(BIN_LDFLAGS)

CLI_LIBDEPS	:=  -L$(mpathutildir) -lmpathutil -L$(mpathcmddir) -lmpathcmd \
		-ludev -ldl -lurcu -lpthread $(SYSTEMD_LIBDEPS)
LIBDEPS		:= -L$(multipathdir) -lmultipath -L$(mpathpersistdir) -lmpathpersist \
	  	-ldevmapper $(CLI_LIBDEPS)

ifeq ($(READLINE),libedit)
RL_CPPFLAGS	:= -DUSE_LIBEDIT
RL_LIBDEPS	:= -ledit
# See comment in multipathc.c
ifeq ($(shell sed -En 's/.*\<Function\s*\*rl_completion_entry_function;.*/yes/p' /usr/include/editline/readline.h),yes)
RL_CPPFLAGS += -DBROKEN_RL_COMPLETION_FUNC
endif
endif
ifeq ($(READLINE),libreadline)
RL_CPPFLAGS	:= -DUSE_LIBREADLINE
RL_LIBDEPS	:= -lreadline
endif

CLI_OBJS := multipathc.o cli.o
OBJS := main.o pidfile.o uxlsnr.o uxclnt.o cli.o cli_handlers.o waiter.o \
       dmevents.o init_unwinder.o
ifeq ($(FPIN_SUPPORT),1)
OBJS += fpin_handlers.o
endif

all : $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service $(EXEC).socket $(EXEC)-queueing.service

$(EXEC): $(OBJS) $(multipathdir)/libmultipath.so $(mpathcmddir)/libmpathcmd.so
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) -o $(EXEC) $(LIBDEPS)

multipathc.o:	multipathc.c
	$(Q)$(CC) $(CPPFLAGS) $(RL_CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

$(CLI):  $(CLI_OBJS)
	@echo building $@ because of $?
	$(Q)$(CC) $(CFLAGS) $(CLI_OBJS) $(LDFLAGS) -o $@ $(CLI_LIBDEPS) $(RL_LIBDEPS)

cli_handlers.o:	cli_handlers.c
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) -Wno-unused-parameter -c -o $@ $<

install:
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(EXEC) $(DESTDIR)$(bindir)
	$(Q)$(INSTALL_PROGRAM) -m 755 $(CLI) $(DESTDIR)$(bindir)
ifdef SYSTEMD
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).service $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC)-queueing.service $(DESTDIR)$(unitdir)
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).socket $(DESTDIR)$(unitdir)
endif
	$(Q)$(INSTALL_PROGRAM) -d $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(EXEC).8 $(DESTDIR)$(mandir)/man8
	$(Q)$(INSTALL_PROGRAM) -m 644 $(CLI).8 $(DESTDIR)$(mandir)/man8

uninstall:
	$(Q)$(RM) $(DESTDIR)$(bindir)/$(EXEC) $(DESTDIR)$(bindir)/$(CLI)
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(EXEC).8
	$(Q)$(RM) $(DESTDIR)$(mandir)/man8/$(CLI).8
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC)-queueing.service
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).service
	$(Q)$(RM) $(DESTDIR)$(unitdir)/$(EXEC).socket

clean: dep_clean
	$(Q)$(RM) core *.o $(EXEC) $(CLI) $(MANPAGES) $(EXEC).service $(EXEC)-queueing.service $(EXEC).socket

include $(wildcard $(OBJS:.o=.d) $(CLI_OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d) $(CLI_OBJS:.o=.d)

=== tests/Makefile ===
include ../Makefile.inc

# directory where to run the tests
TESTDIR := $(CURDIR)

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(mpathcmddir) -I$(daemondir) \
	-DTESTCONFDIR=\"$(TESTDIR)/conf.d\"
CFLAGS += $(BIN_CFLAGS) -Wno-unused-parameter $(W_MISSING_INITIALIZERS)
LIBDEPS += -L. -L $(mpathutildir) -L$(mpathcmddir) -lmultipath -lmpathutil -lmpathcmd -lcmocka

TESTS := uevent parser util dmevents hwtable blacklist unaligned vpd pgpolicy \
	 alias directio valid devt mpathvalid strbuf sysfs features cli mapinfo
HELPERS := test-lib.o test-log.o

.PRECIOUS: $(TESTS:%=%-test)

all:	$(TESTS:%=%.out)
progs:	$(TESTS:%=%-test) lib/libchecktur.so
valgrind:	$(TESTS:%=%.vgr)

# test-specific compiler flags
# XYZ-test_FLAGS: Additional compiler flags for this test

mpathvalid-test_FLAGS := -I$(mpathvaliddir)
features-test_FLAGS := -I$(multipathdir)/nvme

# test-specific linker flags
# XYZ-test_TESTDEPS: test libraries containing __wrap_xyz functions
# XYZ-test_OBJDEPS: object files from libraries to link in explicitly
#    That may be necessary if functions called from the object file are wrapped
#    (wrapping works only for symbols which are undefined after processing a
#    linker input file).
#    Some object files, e.g. "config.o", are compiled separately for the
#    unit tests. Look for OBJS-U in libmultipath/Makefile. Make sure to use the
#    unit test file, e.g. "config-test.o", in XYZ-test_OBJDEPS
# XYZ-test_LIBDEPS: Additional libs to link for this test

dmevents-test_OBJDEPS = $(multipathdir)/devmapper.o
dmevents-test_LIBDEPS = -lpthread -ldevmapper -lurcu
hwtable-test_TESTDEPS := test-lib.o
hwtable-test_OBJDEPS := $(multipathdir)/discovery.o $(multipathdir)/blacklist.o \
	$(multipathdir)/structs_vec.o $(multipathdir)/structs.o $(multipathdir)/propsel.o
hwtable-test_LIBDEPS := -ludev -lpthread -ldl
blacklist-test_TESTDEPS := test-log.o
blacklist-test_LIBDEPS := -ludev
vpd-test_OBJDEPS :=  $(multipathdir)/discovery.o
vpd-test_LIBDEPS := -ludev -lpthread -ldl
alias-test_TESTDEPS := test-log.o
alias-test_OBJDEPS := $(mpathutildir)/util.o
alias-test_LIBDEPS := -ludev -lpthread -ldl
valid-test_OBJDEPS := $(multipathdir)/valid.o $(multipathdir)/discovery.o
valid-test_LIBDEPS := -lmount -ludev -lpthread -ldl
devt-test_LIBDEPS := -ludev
mpathvalid-test_LIBDEPS := -ludev -lpthread -ldl
mpathvalid-test_OBJDEPS := $(mpathvaliddir)/mpath_valid.o
directio-test_LIBDEPS := -laio
strbuf-test_OBJDEPS := $(mpathutildir)/strbuf.o
sysfs-test_TESTDEPS := test-log.o
sysfs-test_OBJDEPS := $(multipathdir)/sysfs.o $(mpathutildir)/util.o
sysfs-test_LIBDEPS := -ludev -lpthread -ldl
features-test_LIBDEPS := -ludev -lpthread
cli-test_OBJDEPS := $(daemondir)/cli.o
mapinfo-test_LIBDEPS = -lpthread -ldevmapper

%.o: %.c
	@echo building $@ because of $?
	$(Q)$(CC) $(CPPFLAGS) $(CFLAGS) $($*-test_FLAGS) -c -o $@ $<

lib/libchecktur.so:
	@mkdir -p lib
	$(Q)cd lib && ln -s ../$(multipathdir)/*/*.so .

%.out:	%-test lib/libchecktur.so
	@echo == running $< ==
	@LD_LIBRARY_PATH=.:$(mpathutildir):$(mpathcmddir) ./$< >$@ 2>&1 || { cat "$@"; false; }

%.vgr:  %-test lib/libchecktur.so
	@echo == running valgrind for $< ==
	@LD_LIBRARY_PATH=.:$(mpathutildir):$(mpathcmddir) \
		valgrind --leak-check=full --error-exitcode=128 ./$< >$@ 2>&1

OBJS = $(TESTS:%=%.o) $(HELPERS)

test_clean:
	$(Q)$(RM) $(TESTS:%=%.out) $(TESTS:%=%.vgr) *.so*

valgrind_clean:
	$(Q)$(RM) $(TESTS:%=%.vgr)

clean: test_clean valgrind_clean dep_clean
	$(Q)$(RM) $(TESTS:%=%-test) $(OBJS) *.o.wrap
	$(Q)$(RM) -rf lib conf.d

.SECONDARY: $(OBJS) $(foreach T,$(TESTS),$($T-test_OBJDEPS)) $(HELPERS:%=%.wrap)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

# Parse the C code for __wrap_xyz() functions and generate linker options from them.
# See comment in wrap64.h
%.o.wrap:	%.c
	$(Q)$(CC) $(OPTFLAGS) $(CPPFLAGS) $($*-test_FLAGS) -E $< | \
		sed -n 's/^.*__wrap_\([a-zA-Z0-9_]*\).*$$/-Wl,--wrap=\1/p' | \
		sort -u | tr '\n' ' ' >$@

# Pass the original values of CFLAGS etc. to the sub-make, which will include
# Makefile.in again. Otherwise, the flags would be added twice.
libmultipath.so.0: $(multipathdir)/libmultipath.so.0
	@CFLAGS="$(ORIG_CFLAGS)" CPPFLAGS="$(ORIG_CPPFLAGS)" LDFLAGS="$(ORIG_LDFLAGS)" \
	$(MAKE) -C $(multipathdir) configdir=$(TESTDIR)/conf.d plugindir=$(TESTDIR)/lib test-lib

# COLON will get expanded during second expansion below
COLON:=:
.SECONDEXPANSION:
%-test:	%.o %.o.wrap $$($$@_OBJDEPS) $$($$@_TESTDEPS) $$($$@_TESTDEPS$$(COLON).o=.o.wrap) \
		libmultipath.so.0 $(mpathutildir)/libmpathutil.so.0 $(mpathcmddir)/libmpathcmd.so.0 Makefile
	@echo building $@
	$(Q)$(CC) $(CFLAGS) -o $@ $(LDFLAGS) $< $($@_TESTDEPS) $($@_OBJDEPS) \
		$(LIBDEPS) $($@_LIBDEPS) \
		$(shell cat $<.wrap) $(foreach dep,$($@_TESTDEPS),$(shell cat $(dep).wrap))

=== libdmmp/test/Makefile ===
# Makefile
#
# Copyright (C) 2015-2016 Gris Ge <fge@redhat.com>
#
TOPDIR := ../..
include ../../Makefile.inc

_libdmmpdir=../$(libdmmpdir)
_mpathcmddir=../$(mpathcmddir)

TEST_EXEC = libdmmp_test
SPD_TEST_EXEC = libdmmp_speed_test
CPPFLAGS += -I$(_libdmmpdir)
LDFLAGS += -L$(_libdmmpdir) -ldmmp

all: $(TEST_EXEC) $(SPD_TEST_EXEC)

check: $(TEST_EXEC) $(SPD_TEST_EXEC)
	$(Q)sudo env LD_LIBRARY_PATH=$(_libdmmpdir):$(_mpathcmddir) \
		valgrind --quiet --leak-check=full \
		--show-reachable=no --show-possibly-lost=no \
		--trace-children=yes --error-exitcode=1 \
		./$(TEST_EXEC)
	$(MAKE) speed_test

speed_test: $(SPD_TEST_EXEC)
	$(Q)sudo env LD_LIBRARY_PATH=$(_libdmmpdir):$(_mpathcmddir) \
		time -p ./$(SPD_TEST_EXEC)

clean: dep_clean
	$(Q)$(RM) -f $(TEST_EXEC) $(SPD_TEST_EXEC)

OBJS = $(TEST_EXEC).o $(SPD_TEST_EXEC).o
include $(wildcard $(OBJS:.o=.d))


dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== libmultipath/checkers/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
TOPDIR = ../..
include ../../Makefile.inc

CPPFLAGS +=  -I$(multipathdir) -I$(mpathutildir)
CFLAGS += $(LIB_CFLAGS)
LDFLAGS += -L$(multipathdir) -L$(mpathutildir)
LIBDEPS = -lmultipath -lmpathutil -laio -lpthread -lrt

# If you add or remove a checker also update multipath/multipath.conf.5
LIBS= \
	libcheckcciss_tur.so \
	libcheckreadsector0.so \
	libchecktur.so \
	libcheckdirectio.so \
	libcheckemc_clariion.so \
	libcheckhp_sw.so \
	libcheckrdac.so

all: $(LIBS)

libcheck%.so: %.o
	$(Q)$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ $(LIBDEPS)

install:
	$(Q)$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(plugindir)

uninstall:
	$(Q)for file in $(LIBS); do $(RM) $(DESTDIR)$(plugindir)/$$file; done

clean: dep_clean
	$(Q)$(RM) core *.a *.o *.gz *.so

OBJS := $(LIBS:libcheck%.so=%.o)
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== libmultipath/foreign/Makefile ===
#
# Copyright (C) 2003 Christophe Varoqui, <christophe.varoqui@opensvc.com>
#
TOPDIR=../..
include ../../Makefile.inc

CPPFLAGS += -I$(multipathdir) -I$(mpathutildir) -I$(nvmedir)
CFLAGS += $(LIB_CFLAGS)
LDFLAGS += -L$(multipathdir) -L$(mpathutildir)
LIBDEPS = -lmultipath -lmpathutil -ludev -lpthread -lrt

LIBS = libforeign-nvme.so

all: $(LIBS)

libforeign-%.so: %.o
	$(Q)$(CC) $(LDFLAGS) $(SHARED_FLAGS) -o $@ $^ $(LIBDEPS)

install:
	$(Q)$(INSTALL_PROGRAM) -m 755 $(LIBS) $(DESTDIR)$(plugindir)

uninstall:
	$(Q)for file in $(LIBS); do $(RM) $(DESTDIR)$(plugindir)/$$file; done

clean: dep_clean
	$(Q)$(RM) core *.a *.o *.gz *.so

OBJS := $(LIBS:libforeign-%.so=%.o)
.SECONDARY: $(OBJS)

include $(wildcard $(OBJS:.o=.d))

dep_clean:
	$(Q)$(RM) $(OBJS:.o=.d)

=== debian/changelog ===
multipath-tools (0.12.0-1ubuntu2) resolute; urgency=medium

  * d/{rules,control}: enable testsuite (LP: #2135118)
    - d/p/testsuite-no-lto: disable lto to workaround testsuite symbol wrapping

 -- Jonas Jelten <jonas.jelten@canonical.com>  Fri, 12 Dec 2025 11:59:36 +0100

multipath-tools (0.12.0-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable (LP: #2126024). Remaining changes:
    - d/rules: don't build the multipath-tools binary package on i386; only kpartx.
    - d/p/enable-find-multipaths.patch: re-enable find_multipaths by
      default -- see the removed 'add_find-multipaths.patch' (LP #1463046)
    - d/t/initramfs: determine extracted main cpio path dynamically
    - d/NEWS: add removal of kpartx-boot package
    - d/rules: remove -Bsymbolic-functions from LDFLAGS
    - d/rules: install friendly names multipath.conf by default
    - d/initramfs: fix multipathd process lingering when local-* initramfs
      scripts are not executed. The multipathd process is started by a script in
      init-top/ (which is executed unconditionally) so it should be
      stopped by an init-bottom script, not a local-bottom script which is
      not always executed (LP #2080474).
      + This is affecting the Ubuntu installer, where we execute (perhaps
        accidentally) the nfs-* scripts instead of the local-* scripts.
    - d/initramfs/scripts/init-top: ensure the bindings file exists before
      calling multipathd -B in the initramfs. This prevents multipathd -B from
      failing and exiting immediately (LP #2120444).

 -- Jonas Jelten <jonas.jelten@canonical.com>  Mon, 01 Dec 2025 16:41:43 +0100

multipath-tools (0.12.0-1) unstable; urgency=medium

  * [faa43cc] New upstream version 0.12.0
  * [6be5e93] Refresh patches
  * [9e3a45d] Install multipathd-queueing.service

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 14 Sep 2025 19:44:45 +0200

multipath-tools (0.11.1-4) unstable; urgency=medium

  * Upload to unstable

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 12 Aug 2025 11:33:45 +0200

=== debian/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
  debhelper-compat (= 13),
 Build-Depends-Arch:
  libaio-dev,
+ libcmocka-dev,
  libdevmapper-dev,
  libedit-dev,
  libmount-dev,

=== debian/rules ===
--- 
+++ 
@@ -47,6 +47,8 @@
 		SYSTEMD= EXTRACFLAGS="-static-libgcc"
 
 override_dh_auto_test:
+	dh_auto_test --sourcedirectory=debian/build-deb
+	dh_auto_test --sourcedirectory=debian/build-udeb
 
 override_dh_auto_install-arch:
 	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
@@ -76,7 +78,7 @@
 	dh_bugfiles -A -pmultipath-tools -pmultipath-tools-boot
 
 override_dh_installsystemd:
-	dh_installsystemd -pmultipath-tools multipathd.service \
+	dh_installsystemd -pmultipath-tools multipathd.service multipathd-queueing.service \
 		--no-stop-on-upgrade
 
 override_dh_makeshlibs:

## multipath-tools 0.13.0

=== debian/changelog ===
multipath-tools (0.13.0-1) unstable; urgency=medium

  * [c8842fd] New upstream version 0.13.0
  * [6951eae] d/rules: enable verbose upstream build
  * [3d82dad] initramfs: stop multipathd in init-bottom, not local-bottom.
    Ubuntu noticed that local-* scripts are not executed on systems with
    disks on network. (LP: #2080474)
  * [fc4b508] d/t/control: add linux-image-generic for Ubuntu
  * [1df3a76] d/libmpathpersist0.symbols: tighten internal symbols
  * [6aff684] initramfs: stop requesting old dmsetup_env hack

 -- Chris Hofstaedtler <zeha@debian.org>  Sat, 20 Dec 2025 14:16:27 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,7 @@
 #!/usr/bin/make -f
-
-ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
-	skip_packages = -Nmultipath-tools
-endif
 
 # For Hardening
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 include /usr/share/dpkg/pkg-info.mk
@@ -23,6 +18,7 @@
 	dh $@
 
 execute_before_dh_clean:
+	rm -f debian/libmpathpersist0.symbols
 	for treename in $(TREENAMES); do \
 		rm -rf debian/$$treename ;\
 	done
@@ -41,21 +37,16 @@
 override_dh_auto_build-indep:
 
 override_dh_auto_build-arch:
-	dh_auto_build --sourcedirectory=debian/build-deb
+	dh_auto_build --sourcedirectory=debian/build-deb -- V=1
 	# multipath-udeb: build separately; don't reference dynamic libgcc at runtime (#779579); disable systemd
-	dh_auto_build --sourcedirectory=debian/build-udeb -- \
+	dh_auto_build --sourcedirectory=debian/build-udeb -- V=1 \
 		SYSTEMD= EXTRACFLAGS="-static-libgcc"
 
 override_dh_auto_test:
-	dh_auto_test --sourcedirectory=debian/build-deb
-	dh_auto_test --sourcedirectory=debian/build-udeb
 
 override_dh_auto_install-arch:
 	dh_auto_install --sourcedirectory=debian/build-deb -- DESTDIR=$(CURDIR)/debian/tmp/deb
 	dh_auto_install --sourcedirectory=debian/build-udeb -- DESTDIR=$(CURDIR)/debian/tmp/udeb
-
-	mkdir -p $(CURDIR)/debian/tmp/deb/etc
-	cp debian/multipath.conf $(CURDIR)/debian/tmp/deb/etc
 
 	# udebs dont get manpages
 	rm -rf $(CURDIR)/debian/tmp/udeb/usr/share/man
@@ -81,12 +72,9 @@
 	dh_installsystemd -pmultipath-tools multipathd.service multipathd-queueing.service \
 		--no-stop-on-upgrade
 
-override_dh_makeshlibs:
-	dh_makeshlibs -a --add-udeb=multipath-udeb
+debian/libmpathpersist0.symbols: debian/libmpathpersist0.symbols.in
+	sed -e 's/$${DEB_VERSION}/${DEB_VERSION}/g' \
+		< $< > $@
 
-override_dh_builddeb:
-	dh_builddeb ${skip_packages}
-
-override_dh_gencontrol:
-	dh_gencontrol ${skip_packages}
-
+override_dh_makeshlibs: debian/libmpathpersist0.symbols
+	dh_makeshlibs -a --add-udeb=multipath-udeb -- -c4
